package com.nmgs.controller;

import cn.hutool.extra.spring.SpringUtil;
import com.alibaba.fastjson.JSONObject;
import com.nmgs.config.SubscribeListener;
import com.nmgs.entity.Consistant;
import com.nmgs.util.WebsocketUtil;
import com.nmgs.util.redisConfigUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.data.redis.listener.ChannelTopic;
import org.springframework.data.redis.listener.RedisMessageListenerContainer;
import org.springframework.stereotype.Component;

import javax.websocket.*;
import javax.websocket.server.PathParam;
import javax.websocket.server.ServerEndpoint;
import java.io.IOException;
import java.util.concurrent.CopyOnWriteArraySet;
import java.util.concurrent.atomic.AtomicInteger;

@Component
@ServerEndpoint(value = "/webSocketCheck/{userId}")
public class WebSocketRedis {
    Log log= LogFactory.getLog(WebSocketRedis.class);

    /**
     * 因为@ServerEndpoint不支持注入，所以使用SpringUtils获取IOC实例
     */
    private RedisMessageListenerContainer redisMessageListenerContainer =
            SpringUtil.getBean(RedisMessageListenerContainer.class);

    /**
     * 静态变量，用来记录当前在线连接数。应该把它设计成线程安全的。
     */
    private static AtomicInteger onlineCount = new AtomicInteger(0);

    /**
     * concurrent包的线程安全Set，用来存放每个客户端对应的webSocket对象。
     * 若要实现服务端与单一客户端通信的话，可以使用Map来存放，其中Key可以为用户标识
     */
    private static CopyOnWriteArraySet<WebSocketRedis> webSocketSet = new CopyOnWriteArraySet<WebSocketRedis>();

    /**
     * 与某个客户端的连接会话，需要通过它来给客户端发送数据
     */
    private Session session;

    /**
     * redis监听
     */
    private SubscribeListener subscribeListener;

    /**
     * 连接建立成功调用的方法
     *
     * @param session 可选的参数。session为与某个客户端的连接会话，需要通过它来给客户端发送数据
     */
    @OnOpen
    public void onOpen(@PathParam("userId") String userId, Session session) throws IOException {
        System.out.println("连接websocket的人员======"+userId);
        this.session = session;
        //加入set中
        webSocketSet.add(this);
        //在线数加1
        addOnlineCount();
        System.out.println("有新连接[" + userId + "]加入！当前在线人数为"+this.getOnlineCount());
        subscribeListener = new SubscribeListener();
        subscribeListener.setSession(session);
        //设置订阅topic
       /* redisMessageListenerContainer.addMessageListener(
                subscribeListener, new ChannelTopic(Consistant.USER + userId));*/
        redisMessageListenerContainer.addMessageListener(
                subscribeListener, new ChannelTopic("USER"));
        redisMessageListenerContainer.addMessageListener(
                subscribeListener, new ChannelTopic("CAR"));
        JSONObject retJo=new JSONObject();
        retJo.put("code",1);
        retJo.put("msg","连接成功");
        retJo.put("data","");
        this.sendMessage(session, retJo.toJSONString());
    }

    /**
     * 连接关闭调用的方法
     */
    @OnClose
    public void onClose(Session session) throws IOException {
        //从set中删除
        webSocketSet.remove(this);
        //在线数减1
        subOnlineCount();
        SubscribeListener subscribeListener = new SubscribeListener();
        subscribeListener.setSession(session);
        redisMessageListenerContainer.removeMessageListener(subscribeListener);
    }

    /**
     * 收到客户端消息后调用的方法
     *
     * @param message 客户端发送过来的消息
     * @param session 可选的参数
     */
    @OnMessage
    public void onMessage(String message, Session session) throws IOException {
        System.out.println("来自客户端的消息:{}"+message);
        JSONObject retJo=new JSONObject();
        retJo.put("code",1);
        retJo.put("msg",message);
        retJo.put("data","");
        this.sendMessage(session, retJo.toJSONString());
    }

    /**
     * 发生错误时调用
     *
     * @param session
     * @param error
     */
    @OnError
    public void onError(Session session, Throwable error) {
        log.info("发生错误，{}", error);
    }

    /**
     * 这个方法与上面几个方法不一样。没有用注解，是根据自己需要添加的方法。
     *
     * @param message
     * @throws IOException
     */
    public void sendMessage(Session session, String message) throws IOException {
        session.getBasicRemote().sendText(message);
    }

    public int getOnlineCount() {
        return onlineCount.get();
    }

    public void addOnlineCount() {
        WebSocketRedis.onlineCount.getAndIncrement();
    }

    public void subOnlineCount() {
        WebSocketRedis.onlineCount.getAndDecrement();
    }
}